<template>
  <div class="people-search">
    <div class="people-search-bar">
      <div class="people-search-bar__field">
        <v-text-field
          v-model="searchInput"
          label="Search people"
          outlined
        />
        <IconifyIcon
          :icon="icons.searchIcon"
          :style="{color: 'rgba(89, 89, 89, 0.9)'}"
          class="people-search-bar__icon"
          width="30px"
          height="30px"
          @click="loadNewPeople"
        />
      </div>
      <v-checkbox
        class="people-search-bar__check"
        v-model="onlyFriends"
        label="Only friends"
      />
    </div>
    <v-list>
      <v-list-item-group v-on:change="e => $router.push({ name: 'Profile', params: { userID: items[e].id } })">
        <v-list-item
          v-for="item in items"
          :key="item.title">
          <v-list-item-content>
            <v-list-item-title v-text="item.title" />
          </v-list-item-content>
          <v-list-item-avatar>
            <v-img :src="item.avatar" />
          </v-list-item-avatar>
        </v-list-item>
      </v-list-item-group>
    </v-list>
  </div>
</template>

<script>
import { GetUsers } from '@/api/users'
import IconifyIcon from '@iconify/vue'
import searchIcon from '@iconify/icons-bi/search'
import { newAvatarS3Link } from '@/js/s3'

export default {
  name: 'People',

  components: {
    IconifyIcon
  },

  data() {
    return {
      icons: {
        searchIcon
      },

      searchInput: '',
      onlyFriends: false,

      items: []
    }
  },

  methods: {
    async loadNewPeople() {
      const names = this.searchInput.split(' ')

      let response
      if (names.length === 1) {
        response = await GetUsers({ anyName: names[0], friends: this.onlyFriends }, 8)
      } else {
        response = await GetUsers({ firstName: names[0], lastName: names[1], friends: this.onlyFriends }, 8)
      }
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
      }

      const newItems = []
      response.data.data.data.forEach(e => newItems.push({
        title: e.attributes.first_name + ' ' + e.attributes.last_name,
        avatar: e.attributes.has_avatar ? newAvatarS3Link(e.id) : "/dummy.png",
        id: e.id
      }))

      this.$set(this, 'items', [...newItems])
    }
  }
}
</script>

<style>
.people-search {
  position: absolute;
  width: 400px;
  left: 50%;
  transform: translate(-50%, 0);
  margin-top: 25px;
}

.people-search-bar__icon {
  margin-top: 12px;
  margin-left: 12px;
}

.people-search-bar__icon:hover {
  cursor: pointer;
}

.people-search-bar__field {
  display: flex;
}

.people-search-bar__check {
  margin-top: -25px !important;
  margin-left: 10px;
}
</style>
